import { BlockLocation, ItemStack, MinecraftEnchantmentTypes, MinecraftItemTypes, world } from "mojang-minecraft";

var entry_time = 0;

const need_notification = {};

const id_to_name = {
	"luminescent:render_forge": "Floral Forge",
	"luminescent:render_garden_glass_house": "Garden Glass House"
};

const block_to_placer = {
	"luminescent:ambar_block": {
		"id": "luminescent:ambar_flower",
		"data": 0
	},
	"luminescent:apatita_block": {
		"id": "luminescent:apatita_flower",
		"data": 0
	},
	"luminescent:jaspe_block": {
		"id": "luminescent:jaspe_flower",
		"data": 0
	},
	"luminescent:hematita_block": {
		"id": "luminescent:hematita_flower",
		"data": 0
	},
	"luminescent:turqueza_block": {
		"id": "luminescent:turqueza_flower",
		"data": 0
	},

	"luminescent:allium_block": {
		"id": "minecraft:red_flower",
		"data": 2
	},
	"luminescent:blue_orchid_block": {
		"id": "minecraft:red_flower",
		"data": 1
	},
	"luminescent:cornflower_block": {
		"id": "minecraft:red_flower",
		"data": 9
	},
	"luminescent:dandelion_block": {
		"id": "minecraft:yellow_flower",
		"data": 0
	},
	"luminescent:houstonia_block": {
		"id": "minecraft:red_flower",
		"data": 3
	},
	"luminescent:lily_block": {
		"id": "minecraft:red_flower",
		"data": 10
	},
	"luminescent:oxeye_daisy_block": {
		"id": "minecraft:red_flower",
		"data": 8
	},
	"luminescent:paeonia_block": {
		"id": "minecraft:double_plant",
		"data": 5
	},
	"luminescent:poppy_block": {
		"id": "minecraft:red_flower",
		"data": 0
	},
	"luminescent:tulip_orange_block": {
		"id": "minecraft:red_flower",
		"data": 5
	},
	"luminescent:tulip_pink_block": {
		"id": "minecraft:red_flower",
		"data": 7
	},
	"luminescent:tulip_red_block": {
		"id": "minecraft:red_flower",
		"data": 4
	},
	"luminescent:tulip_white_block": {
		"id": "minecraft:red_flower",
		"data": 6
	},
	"luminescent:wither_rose_block": {
		"id": "minecraft:wither_rose",
		"data": 0
	}
};

const item_description = {
	"luminescent:apatita_flower": "§cSilkTouch by LumGarden",
	"luminescent:ambar_flower": "§cSharpness by LumGarden",
	"luminescent:jaspe_flower": "§cEfficiency by LumGarden",
	"luminescent:hematita_flower": "§cUnbreaking by LumGarden",
	"luminescent:turqueza_flower": "§cFortune by LumGarden",

	"luminescent:floral_patchable_iron_ingot": "§cMending Beacon by LumGarden",
	"luminescent:floral_infernal_iron_ingot": "§cFire Beacon by LumGarden",
	"luminescent:floral_tempered_iron_ingot": "§cVein Miner by LumGarden",
	"luminescent:floral_experient_iron_ingot": "§cExperience Miner by LumGarden"

};

const recipes = {
	"luminescent:ambar_flower": {
		"id": "sharpness",
		"levels": [ 1, 2, 3]
	},
	"luminescent:apatita_flower": {
		"id": "silk_touch", "gid": "silkTouch",
		"level": 1
	},
	"luminescent:jaspe_flower": {
		"id": "efficiency",
		"levels": [ 1, 2, 3, 4, 5]
	},
	"luminescent:hematita_flower": {
		"id": "unbreaking",
		"levels": [ 1, 2, 3]
	},
	"luminescent:turqueza_flower": {
		"id": "fortune",
		"levels": [ 1, 2, 3]
	},

	"luminescent:floral_patchable_iron_ingot": {
		"id": "mending",
		"level": 1
	},
	"luminescent:floral_infernal_iron_ingot": {
		"type": "custom",
		"id" : "§bFire Beacon by LumGarden"
	},
	"luminescent:floral_tempered_iron_ingot": {
		"type": "custom",
		"id" : "§4Vein Miner by LumGarden"
	},
	"luminescent:floral_experient_iron_ingot": {
		"type": "custom",
		"id" : "§1Experience Miner by LumGarden"
	}
};

const fire_beacon = {
	"minecraft:cobblestone": {
		"id": "minecraft:stone",
		"data": 0
	},
	"minecraft:raw_iron": {
		"id": "minecraft:ironIngot",
		"data": 0
	},
	"minecraft:raw_gold": {
		"id": "minecraft:goldIngot",
		"data": 0
	},
	"minecraft:raw_copper": {
		"id": "minecraft:copperIngot",
		"data": 0
	}
};

const ores = {
	"minecraft:iron_ore": {
		"id": "minecraft:raw_iron"
	},
	"minecraft:deepslate_iron_ore": {
		"id": "minecraft:raw_iron"
	},

	"minecraft:gold_ore": {
		"id": "minecraft:raw_gold"
	},
	"minecraft:deepslate_gold_ore": {
		"id": "minecraft:raw_gold"
	},
	"minecraft:nether_gold_ore": {
		"id": "minecraft:gold_nugget"
	},

	"minecraft:copper_ore": {
		"id": "minecraft:raw_copper"
	},

	"minecraft:diamond_ore": {
		"id": "minecraft:diamond"
	},
	"minecraft:deepslate_diamond_ore": {
		"id": "minecraft:diamond"
	},

	"minecraft:emerald_ore": {
		"id": "minecraft:emerald"
	},
	"minecraft:deepslate_emerald_ore": {
		"id": "minecraft:emerald"
	},

	"minecraft:coal_ore": {
		"id": "minecraft:coal"
	},
	"minecraft:deepslate_coal_ore": {
		"id": "minecraft:coal"
	},

	"minecraft:lapis_ore": {
		"id": "minecraft:lapis_lazuli",
		"multiplier": 2
	},
	"minecraft:deepslate_lapis_ore": {
		"id": "minecraft:lapis_lazuli",
		"multiplier": 2
	},

	"minecraft:redstone_ore": {
		"id": "minecraft:redstone",
		"multiplier": 2
	},
	"minecraft:deepslate_redstone_ore": {
		"id": "minecraft:redstone",
		"multiplier": 2
	},

	"minecraft:quartz_ore": {
		"id": "minecraft:quartz"
	},
	"minecraft:amethyst_cluster": {
		"id": "minecraft:amethyst_shard"
	},
};

class Timer {
	static timers = {};

	static add(callback,delay,key,params){
		Timer.timers[key]={
			"delay": delay,
			"current": Date.now(),
			"callback": callback,
			"params": params
		}
	}

	static verify(key){
		const timer = Timer.timers[key];

		if(timer.current+timer.delay < Date.now()){
			timer.callback(timer.params);
			delete Timer.timers[key];
		}
	}

	static verifyAll(){
		Object.keys(this.timers).forEach(timer=>{
			this.verify(timer);
		});
	}
};

const breakCounter = {};

function fvoid( data ){};

function stc( str ){
	let new_str = '';

	str.split('_').forEach(name=>{
		new_str+=(name.charAt(0).toUpperCase() + name.slice(1));
	});

	return (new_str.charAt(0).toLowerCase() + new_str.slice(1));
};

function searchMatchs( id, position, player, brokenBlockPermutation, counter){
	const { x, y, z} = position;

	[x-1,x,x+1].forEach(xx=>{
		[y-1,y,y+1].forEach(yy=>{
			[z-1,z,z+1].forEach(zz=>{
				if(breakCounter[counter]){
					const new_position = new BlockLocation( xx, yy, zz);
					const current_block = player.dimension.getBlock(new_position);

					if(current_block.id == id){
						if(++breakCounter[counter] <= 13){
							const container = player.getComponent('inventory').container;
							const item = container.getItem(player.selectedSlot);
							const enchantments = item.getComponent('minecraft:enchantments');

							if(enchantments){
								if(enchantments.enchantments.hasEnchantment(MinecraftEnchantmentTypes.silkTouch)){
									const item_type = MinecraftItemTypes[stc(current_block.id.split(':')[1])];

									if(item_type){
										const stack = new ItemStack( item_type, 1, 0);
	
										player.dimension.spawnItem( stack, new_position);
										player.runCommand(`setblock ${xx} ${yy} ${zz} air 0 replace`);
									} else 
										player.runCommand(`setblock ${xx} ${yy} ${zz} air 0 destroy`);	
								} else if(enchantments.enchantments.hasEnchantment(MinecraftEnchantmentTypes.fortune)){
									const level = enchantments.enchantments.getEnchantment(MinecraftEnchantmentTypes.fortune).level;
									const ore_drop = ores[current_block.id];

									if(ore_drop){
										const item_type = MinecraftItemTypes[stc(ore_drop.id.split(':')[1])];
										const stack = new ItemStack( item_type, Math.floor(Math.random()*(level+(ore_drop.multiplier??0))), ore_drop.data??0);

										if(stack.amount > 0)
											player.dimension.spawnItem( stack, new_position);
										player.runCommand(`setblock ${xx} ${yy} ${zz} air 0 destroy`);
									} else {
										player.runCommand(`setblock ${xx} ${yy} ${zz} air 0 destroy`);
									}
								} else 
									player.runCommand(`setblock ${xx} ${yy} ${zz} air 0 destroy`);
							} else
								player.runCommand(`setblock ${xx} ${yy} ${zz} air 0 destroy`);
							
							item.getLore().forEach(lore => {
								if(lore != "§4Vein Miner by LumGarden" && custom_enchantments[lore])
									custom_enchantments[lore]({ player, item, brokenBlockPermutation, "location": new_position });
							});

							Timer.add( data => {
								searchMatchs( id, new_position, player, brokenBlockPermutation, counter);
							}, breakCounter[counter]*13, counter+(breakCounter[counter]*13), {
								id, new_position, player, brokenBlockPermutation, counter
							})
						} else
							delete breakCounter[counter];
					}
				}
			})
		})
	})
};

const custom_enchantments = {
	"§bFire Beacon by LumGarden": ( data ) => {
		const { player, item, location, brokenBlockPermutation } = data;
		const { x, y, z} = location;

		[x-1,x,x+1].forEach(xx=>{
			[y-1,y,y+1].forEach(yy=>{
				[z-1,z,z+1].forEach(zz=>{

					try {
						const rLocation = new BlockLocation( xx, yy, zz);

						Timer.add((data)=>{
							const { player, rLocation, xx, yy, zz } = data;
	
							player.dimension.getEntitiesAtBlockLocation(rLocation).forEach(entity => {
								if(entity.id == 'minecraft:item'){
									const droped = entity.getComponent('minecraft:item').itemStack;
		
									if(fire_beacon[droped.id]){
										const recipe = fire_beacon[droped.id];
		
										entity.dimension.spawnItem( new ItemStack( MinecraftItemTypes[recipe.id.split(':')[1]], droped.amount, recipe.data), location);
										entity.dimension.runCommand( `particle minecraft:mobflame_single ${xx} ${yy} ${zz}`);
										entity.kill();
									}
								}
							})
						},500,`FB${xx} ${yy} ${zz}`,{
							player, rLocation, xx, yy, zz
						})
					} catch (error){}
					
				})
			})
		})
	},
	"§4Vein Miner by LumGarden": ( data ) => {
		const { player, item, location, brokenBlockPermutation } = data;
		const { x, y, z} = location;
		const id = `${x} ${y} ${z}`;

		try {
			breakCounter[id] = 1;

			searchMatchs( brokenBlockPermutation.type.id, location, player, brokenBlockPermutation, id);
			
			Timer.add(data=>{
				const { id } = data;

				if(breakCounter[id])
					delete breakCounter[id];
			}, 500, `exclusion ${id}`,{id});
			
		} catch(error) {
			player.runCommand(`say error ${error}`);
		}
	},
	"§1Experience Miner by LumGarden": ( data ) => {
		const { player, item, location, brokenBlockPermutation } = data;
		const { x, y, z} = location;

		player.dimension.spawnEntity( 'minecraft:xp_orb', location);
	}
};

const commands = {
	"%rl": data => {
		const { sender } = data;

		sender.runCommand(
			`tell "${sender.nameTag}" §b`+
			`\n§4============== `+
			`\n§bAmbar = dandelion, poppy, dandelion`+
			`\n§bApatita = cornflower, poppy, cornflower`+
			`\n§bHematita = pink tulip, wither rose, allium`+
			`\n§bJaspe = poppy, dandelion, poppy`+
			`\n§bTurqueza = cornflower, dandelion, cactus`+
			`\n§4==============`+
			`\n§cyou can find the recipes visually at www.com.com.com`+
			`\n§4==============`+
			`\n§cMessage by LumGarden`
		);
	},
	"%lum": data => {
		const { sender } = data;

		sender.addTag('notified');
		delete need_notification[sender.nameTag];

		sender.runCommand(
			`tell "${sender.nameTag}" §b`+
			`\n%rl to get the recipes for the special seedlings`+
			`\n(the others are obtained by placing a flower in the first slot of the seed handler)`+
			`\n§cMessage by LumGarden`
		);
	}
};

world.events.playerJoin.subscribe( data => {
	const { player } = data;

	if(!player.hasTag('notified'))
		need_notification[player.nameTag] = true;
});

world.events.beforeChat.subscribe( data => {
	if(commands[data.message]){
		commands[data.message](data);
		data.cancel = true;
	}
});

world.events.tick.subscribe( data => {
	if(Date.now()%20==0){
		Array.from(world.getPlayers()).forEach(player=>{
			const container = player.getComponent('inventory').container;
	
			for(var slot = 0; slot  < container.size; slot++){
				const item = container.getItem(slot);
	
				if(item){
					const lore = item.getLore();
					const description = item_description[item.id];
	
					if(description && !lore.includes(description)){
						lore.push(description);
						item.setLore(lore);
						container.setItem(slot,item);
					}
				}
			}

			if(need_notification[player.nameTag])
				player.runCommand(`title @s actionbar §4type %lum in chat.`);
		})
	};

	Timer.verifyAll();
});

world.events.blockBreak.subscribe( data => {
	const { block, dimension, player, brokenBlockPermutation } = data;
	const { location } = block;
	const { x, y, z } = location;
	const r = 1;

	if(player){
		const container = player.getComponent('inventory').container;
		const item = container.getItem(player.selectedSlot);
		
		item.getLore().forEach(lore => ((custom_enchantments[lore]??fvoid)({ player, item, brokenBlockPermutation, location })));
	};

	if(brokenBlockPermutation.hasTag('render')){
		dimension.getEntitiesAtBlockLocation(location).forEach(entity=>{
			try {
				entity.triggerEvent('give');
			} catch(e){}
		})
	}
});

world.events.blockPlace.subscribe( data => {
	const { block, dimension } = data;
	const { id, location } = block;
	const { x, y, z } = location;

	const nid = id.split(':');

	if(data.player && block.hasTag('render')){
		dimension.runCommand(`setblock ${x} ${y} ${z} air`);

		const entity = dimension.spawnEntity( nid[0]+':render_'+nid[1], location);

		entity.runCommand(`tp @s ${x} ${y} ${z}`);
		entity.runCommand(`event entity @s tick`);

		dimension.runCommand(`setblock ${x} ${y} ${z} ${id}`);
	}
});

const tick_by_id = {
	"luminescent:render_forge": data => {
		// dandelion, allium, poppy, lily, wither rose
	},
	"luminescent:render_garden_glass_house": data => {
		const { entity } = data;
		const container = entity.getComponent('inventory').container;

		for(var i = 0; i < 36; i++){
			const item = container.getItem(i);

			const x = Math.floor(entity.location.x);
			const y = Math.floor(entity.location.y);
			const z = Math.floor(entity.location.z);

			if(item && item.id == 'minecraft:bone_meal'){
				const air = new ItemStack(MinecraftItemTypes.air, 0, 0);
				const location = new BlockLocation( x, y+1, z);
				const block = entity.dimension.getBlock(location);
				const id = block.id;

				if(block.hasTag('flower') && container.emptySlotsCount > 0){
					const ie = entity.dimension.spawnEntity( 'luminescent:inventory', location);
					const iec = ie.getComponent('inventory').container;
					const nb = block_to_placer[id];

					try {
						ie.runCommand(`replaceitem entity @s slot.inventory 0 ${nb.id} 1 ${nb.data}`);

						container.addItem(iec.getItem(0));
						iec.setItem( 0, air);
						ie.runCommand('tp @s ~ ~60 ~');
					} catch( error ){

					};

					ie.kill();

					entity.runCommand(`particle minecraft:crop_growth_emitter ${x} ${y+1} ${z}`);

					if(--item.amount > 0){
						container.setItem( i, item);
					} else {
						container.setItem( i, air);
					};

					i = 36;
				}
			}
		}
	}
};

world.events.effectAdd.subscribe( data => {
	const { entity } = data;

	entity.nameTag = id_to_name[entity.id] ?? entity.nameTag;

	if(tick_by_id[entity.id])
		tick_by_id[entity.id](data);
});

world.events.beforeItemUseOn.subscribe( data => {
	if(entry_time+500 < Date.now()){
		entry_time = 0;

		const { blockLocation, item, source } = data;
		const { x, y, z } = blockLocation;

		if(item.id == 'luminescent:hammer'){
			
			source.dimension.getEntitiesAtBlockLocation(blockLocation).forEach(entity => {
				if(entity.id == 'luminescent:render_forge'){
					entity.nameTag = "Floral Forge";

					var enchantment_level = 0;
					
					try {
						[x-1,x,x+1].forEach(xx => {
							[z-1,z,z+1].forEach(zz => {
								if(source.dimension.getBlock(new BlockLocation( xx, y-1, zz)).id == 'luminescent:lumwood')
									enchantment_level += 0.2;
							})
						});
	
						[x-1,x+1].forEach(xx => {
							[y,y+1].forEach(yy => {
								[z-2,z+2].forEach(zz => {
									if(source.dimension.getBlock(new BlockLocation( xx, y, zz)).id == 'luminescent:quartz_pilar')
										enchantment_level += 0.2;
								})
							})
						});
	
						[x-2,x+2].forEach(xx => {
							[y,y+1].forEach(yy => {
								[z-1,z+1].forEach(zz => {
									if(source.dimension.getBlock(new BlockLocation( xx, yy, zz)).id == 'luminescent:quartz_pilar')
										enchantment_level += 0.2;
								})
							})
						});
					} catch(error) {
						source.runCommand(`say erro 1 em: ${error}`)
					};

					enchantment_level = Math.floor(enchantment_level);

					const s_container = source.getComponent('inventory').container;
					const e_container = entity.getComponent('inventory').container;
					
					if(e_container.emptySlotsCount < 13){
						const item_new = e_container.getItem(0);
						const lore = item_new.getLore();

						if(!item_new)
							return;
						
						s_container.setItem(source.selectedSlot,item_new);

						const valid = {};

						[ 1, 2, 3, 4].forEach( index => {
							const material = e_container.getItem(index);
							
							if(material && recipes[material.id])
								valid[material.id] = index;
						});

						Object.keys(valid).forEach( key => {
							const index = valid[key];
							const material = e_container.getItem(index);
							
							if(material && recipes[material.id]){
								const recipe = recipes[material.id];
								const gid = recipe.gid ? recipe.gid : recipe.id;

								var level = 1;

								try {
									if(recipe.levels){
										const { levels } = recipe;

										level = (enchantment_level>=levels.length)?levels[levels.length-1]:levels[enchantment_level];
									} else {
										level = recipe.level;
									};
								} catch(error) {
									source.runCommand(`say erro 2 em: ${error}`)
								};

								try {

									if(recipe.type == 'custom'){
										if(lore.includes(recipe.id))
											return;
										lore.push(recipe.id);
									} else {
										if(material.getComponent('minecraft:enchantments').enchantments.hasEnchantment(MinecraftEnchantmentTypes[gid]))
											return;
										source.runCommand(`enchant @s ${recipe.id} ${level}`);
									}
									
									if(material.amount-- > 1)
										e_container.setItem(index,material);
									else
										e_container.setItem(index,new ItemStack(MinecraftItemTypes.air,0,0));
								} catch (e) {
									source.runCommand('say impossivel encantar com '+recipe.id);
								}
							}
						});

						if(item_new.amount-- > 1)
							source.dimension.spawnItem( item_new, blockLocation);
						
						const item_final = s_container.getItem(source.selectedSlot);
						item_final.setLore(lore);

						e_container.setItem(0,item_final);
						s_container.setItem(source.selectedSlot,item);

						source.runCommand(`particle minecraft:crop_growth_emitter ${x} ${y+1} ${z}`);
					}
				}
			})
		}
	};

	if(entry_time == 0)
		entry_time = Date.now();
});